const playerData = new JsonConfigFile('plugins/playerData/players.json');

const CHANGE_INFO_COST = 5000;  //修改个人信息的费用llmoney

function createInfoForm(player, isFirstTime) {
    let form = mc.newCustomForm()
        .setTitle('§a§l设置个人信息')
        .addInput('§aQQ号', '请输入你的QQ号')
        .addInput('§a微信号', '请输入你的微信号')
        .addInput('§a爱好', '请输入你的爱好')
        .addInput('§a偶像', '请输入你的偶像')
        .addInput('§a年龄', '请输入你的年龄')
        .addInput('§a身高', '请输入你的身高')
        .addInput('§a体重', '请输入你的体重')
        .addDropdown('§a性别', ['男', '女', '其他'], 0)
        .addInput('§a个性签名', '请输入你的个性签名 (最多30个字)', '', 30);

    player.sendForm(form, (player, data) => {
        if (data === undefined) {
            player.tell('§a你关闭了表单。请下次加入时填写。');
            return;
        }

        if (!isFirstTime && money.get(player.xuid) < CHANGE_INFO_COST) {
            player.tell(`§c修改信息需要${CHANGE_INFO_COST}金币，你的金币不足。`);
            return;
        }

        if (!isFirstTime) {
            money.reduce(player.xuid, CHANGE_INFO_COST);
        }

        playerData.set(player.xuid, {
            qq: data[0],
            wechat: data[1],
            hobbies: data[2],
            idol: data[3],
            age: data[4],
            height: data[5],
            weight: data[6],
            gender: ['男', '女', '不辨雌雄'][data[7]],
            signature: data[8]
        });

        player.tell('§a你的信息已保存。');
    });
}

mc.listen('onJoin', (player) => {
    if (!playerData.get(player.xuid)) {
        createInfoForm(player, true);
    }
});

mc.regPlayerCmd('ckxx', '§a查看在线玩家信息', (player, args) => {
    let form = mc.newSimpleForm()
        .setTitle('§a在线玩家')
        .setContent('§a选择一个玩家查看他们的信息');

    let onlinePlayers = mc.getOnlinePlayers();
    let playerNames = onlinePlayers.map(pl => pl.realName); // 获取所有在线玩家的名字列表

    onlinePlayers.forEach((pl) => {
        form.addButton(pl.realName, 'textures/ui/icon_steve');
    });

    player.sendForm(form, (player, id) => {
        if (id === null) return;

        let selectedPlayerName = playerNames[id]; // 根据玩家选择的id获取玩家名字
        let selectedPlayer = onlinePlayers.find(pl => pl.realName === selectedPlayerName); // 根据名字找到对应的玩家对象

        if (selectedPlayer) {
            let data = playerData.get(selectedPlayer.xuid);
            if (data) {
                let infoForm = mc.newCustomForm()
                    .setTitle(`${selectedPlayer.realName}§a的信息`)
                    .addLabel(
                        `§aQQ号: ${data.qq}\n` +
                        `§a微信号: ${data.wechat}\n` +
                        `§a爱好: ${data.hobbies}\n` +
                        `§a偶像: ${data.idol}\n` +
                        `§a年龄: ${data.age}\n` +
                        `§a身高: ${data.height}\n` +
                        `§a体重: ${data.weight}\n` +
                        `§a性别: ${data.gender}\n` +
                        `§a个性签名: ${data.signature}\n` +
                        `§a个人金币: ${money.get(selectedPlayer.xuid)}`
                    );

                player.sendForm(infoForm, (player, data) => {});
            } else {
                player.tell('§e无法找到该玩家的信息。');
            }
        }
    });
});

mc.regPlayerCmd('xgxx', '§a修改个人信息', (player, args) => {
    createInfoForm(player, false);
});
